Package com.mckoi.database

## Interface RawDiagnosticTable

    public interface RawDiagnosticTable

An interface that allows for the inspection and repair of the raw data in a file. This is used for table debugging and the repair of damaged files.

Author:
  Tobias Downer

### Field Summary

Fields
`static int` `COMMITTED_ADDED` Statics that represent the various states of a record.
`static int` `COMMITTED_REMOVED` Statics that represent the various states of a record.
`static int` `DELETED` Statics that represent the various states of a record.
`static int` `RECORD_STATE_ERROR` Denotes an erroneous record state.
`static int` `UNCOMMITTED` Statics that represent the various states of a record.

### Method Summary

All Methods Instance Methods Abstract Methods
`TObject` `getCellContents​(int column, int record_index)` Returns the contents of the given cell in this table.
`DataTableDef` `getDataTableDef()` Returns the DataTableDef object that describes the logical topology of the columns in this table.
`int` `physicalRecordCount()` Returns the number of physical records in the table.
`java.lang.String` `recordMiscInformation​(int record_index)` Returns any misc information regarding this row as a human readable string.
`int` `recordSize​(int record_index)` The number of bytes the record takes up on the underlying media.
`int` `recordState​(int record_index)` Returns the state of the given record index.

### Field Detail

#### UNCOMMITTED

    static final int UNCOMMITTED

Statics that represent the various states of a record.

See Also:
  Constant Field Values

#### COMMITTED_ADDED

    static final int COMMITTED_ADDED

Statics that represent the various states of a record.

See Also:
  Constant Field Values

#### COMMITTED_REMOVED

    static final int COMMITTED_REMOVED

Statics that represent the various states of a record.

See Also:
  Constant Field Values

#### DELETED

    static final int DELETED

Statics that represent the various states of a record.

See Also:
  Constant Field Values

#### RECORD_STATE_ERROR

    static final int RECORD_STATE_ERROR

Denotes an erroneous record state.

See Also:
  Constant Field Values

### Method Detail

#### physicalRecordCount

    int physicalRecordCount()

Returns the number of physical records in the table. This includes records that are uncommitted, deleted, committed removed and committed added.

#### getDataTableDef

    DataTableDef getDataTableDef()

Returns the DataTableDef object that describes the logical topology of the columns in this table.

#### recordState

    int recordState​(int record_index)

Returns the state of the given record index. The state of a row is either UNCOMMITTED, COMMITTED ADDED, COMMITTED REMOVED or DELETED. record_index should be between 0 and physicalRecordCount.

#### recordSize

    int recordSize​(int record_index)

The number of bytes the record takes up on the underlying media.

#### getCellContents

    TObject getCellContents​(int column,
                            int record_index)

Returns the contents of the given cell in this table. If the system is unable to return a valid cell then an exception is thrown.

#### recordMiscInformation

    java.lang.String recordMiscInformation​(int record_index)

Returns any misc information regarding this row as a human readable string. May return null if there is no misc information associated with this record.